# $Revision: 1.28 $, $Date: 2006/11/21 19:56:48 $
# TODO:
# - solve requires issue (something like patch0, but a bit extended?)
# - maybe PhpDocumentor.ini should go to /etc/php ?
# - subpackage for -tutorial?
# - subpackage for -cli?
# - subpackage docBuilder for web interface in %{php_pear_dir}/data/%{_pearname}
# - treemenu needs patching (removing from this package)
%include	/usr/lib/rpm/macros.php
%define		_class		PhpDocumentor
%define		_status		stable
%define		_pearname	%{_class}

Summary:	%{_pearname} - provides automatic documenting of PHP API directly from source
Summary(pl):	%{_pearname} - automatyczne tworzenie dokumentacji API PHP prosto ze rde
Name:		php-pear-%{_pearname}
Version:	1.3.1
Release:	2
Epoch:		0
License:	PHP 3.00
Group:		Development/Languages/PHP
Source0:	http://pear.php.net/get/%{_pearname}-%{version}.tgz
# Source0-md5:	4209e449b2b94180f3bf6bc74cf3031f
Patch0:		%{name}-includes_fix.patch
Patch1:		%{name}-smarty.patch
Patch2:		%{name}-html_treemenu_includes_fix.patch
URL:		http://pear.php.net/package/PhpDocumentor/
BuildRequires:	php-pear-PEAR
BuildRequires:	rpm-php-pearprov >= 4.4.2-10.2
BuildRequires:	rpmbuild(macros) >= 1.300
Requires:	Smarty >= 2.6.10-4
Requires:	php(pcre)
Requires:	php(tokenizer)
Requires:	php-cli
Requires:	php-common >= 3:4.3.0
Requires:	php-pear >= 4:1.0-2.8
Requires:	php-pear-Archive_Tar >= 1.1
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_smartyplugindir	%{_datadir}/php/Smarty/plugins

# exclude optional dependencies
# don't require %{php_pear_dir}/data files we provide.
%define		_noautoreq	'pear(phpDocumentor/.*)' 'pear(%{php_pear_dir}/data/.*)' 'pear(XML/Beautifier/.*)' 'pear(HTML_TreeMenu-1.1.2/TreeMenu.php)'

%description
The phpDocumentor tool is a standalone auto-documentor similar to
JavaDoc written in PHP. It differs from PHPDoc in that it is MUCH
faster, parses a much wider range of PHP files, and comes with many
customizations including 11 HTML templates, windows help file CHM
output, PDF output, and XML DocBook peardoc2 output for use with
documenting PEAR. In addition, it can do PHPXref source code
highlighting and linking.

Features (short list):
- output in HTML, PDF (directly), CHM (with windows help compiler),
  XML DocBook
- very fast
- web and command-line interface
- fully customizable output with Smarty-based templates
- recognizes JavaDoc-style documentation with special tags customized
  for PHP 4
- automatic linking, class inheritance diagrams and intelligent
  override
- customizable source code highlighting, with phpxref-style
  cross-referencing
- parses standard README/CHANGELOG/INSTALL/FAQ files and includes them
  directly in documentation
- generates a todo list from @todo tags in source
- generates multiple documentation sets based on @access private,
  @internal and {@internal} tags
- example PHP files can be placed directly in documentation with
  highlighting and phpxref linking using the @example tag
- linking between external manual and API documentation is possible at
  the sub-section level in all output formats
- easily extended for specific documentation needs with Converter
- full documentation of every feature, manual can be generated
  directly from the source code with "phpdoc -c makedocs" in any format
  desired.
- current manual always available at http://www.phpdoc.org/manual.php
- user .ini files can be used to control output, multiple outputs can
  be generated at once

In PEAR status of this package is: %{_status}.

%description -l pl
phpDocumentor jest podobnym do JavaDoc samodzielnym narzdziem do
automatycznego tworzenia dokumentacji napisanym w PHP. W porwnaniu do
PHPDoc jest duo szybszy, parsuje wikszy zakres plikw PHP, oraz
umoliwia dostosowanie do upodoba uytkownika za pomoc midzy innymi
11 szablonw HTML, moliwoci zapisu plikw w formacie plikw pomocy
Windows (CHM), PDF czy XML DocBook peardoc2 (uywanym przy tworzeniu
dokumentacji do PEAR). Ponadto phpDocumentor moe podwietla i czy
kod rdowy za pomoc PHPXref.

Moliwoci (krtka lista):
- zapis do formatu HTML, PDF (bezporednio), CHM (za pomoc
  kompilatora plikw pomocy windows), XML DocBook
- bardzo szybki
- interfejs WWW oraz z linii polece
- w peni konfigurowalny zapis z uyciem szablonw opartych o Smarty
- rozpoznaje dokumentacj JavaDoc za pomoc specjalnych znacznikw
  dostosowanych do PHP 4
- automatyczne czenie, diagramy dziedziczenia klas i inteligentne
  przesanianie
- konfigurowalne podwietlanie kodu rdowego z odnonikami w stylu
  phpxref
- parsuje standardowe pliki README/CHANGELOG/INSTALL/FAQ i docza je
  bezporednio do dokumentacji
- generuje list do zrobienia korzystajc ze znacznikw @todo w kodzie
- generuje rn dokumentacj w zalenoci od znacznikw @access
  private, @internal i {@internal}
- przykadowe pliki PHP mog by umieszczane bezporednio w
  dokumentacji z podwietlaniem skadni i poczeniami phpxref za pomoc
  znacznika @example
- poczenia pomidzy zewntrznym podrcznikiem i dokumentacj API
  jest moliwe na poziomie podsekcji we wszystkich formatach wyjciowych
- atwo rozszerzalny za pomoc Convertera dla specyficznych potrzeb
  dokumentacji
- pena dokumentacja kadej z moliwoci, podrcznik moe by
  wygenerowany bezporednio z kodu rdowego za pomoc "phpdoc -c
  makedocs" w dowolnie wybranym formacie
- aktualny podrcznik zawsze dostpny pod adresem
  http://www.phpdoc.org/manual.php
- za pomoc plikw .ini mona kontrolowa format wyjcia, mona
  generowa kilka dokumentw naraz

Ta klasa ma w PEAR status: %{_status}.

%package tests
Summary:	Tests for PEAR::%{_pearname}
Summary(pl):	Testy dla PEAR::%{_pearname}
Group:		Development/Languages/PHP
Requires:	%{name} = %{epoch}:%{version}-%{release}
AutoReq:	no
AutoProv:	no

%description tests
Tests for PEAR::%{_pearname}.

%description tests -l pl
Testy dla PEAR::%{_pearname}.

%prep
%pear_package_setup
%patch0 -p1
%patch1 -p1

rm -f docs/%{_pearname}/PHPLICENSE # PHP License

# remove bundled Smarty. use system one.
mkdir plugins
mv ./%{php_pear_dir}/PhpDocumentor/phpDocumentor/Smarty-*/libs/plugins/\
{block.strip.php,function.{assign,var_dump}.php,modifier.{htmlentities,rawurlencode}.php} plugins
rm -rf ./%{php_pear_dir}/PhpDocumentor/phpDocumentor/Smarty-*
rm -rf ./%{php_pear_dir}/data/PhpDocumentor/phpDocumentor/Smarty-*

# packaging corrections. we want sample scripts in doc
install -d docs/%{_pearname}
mv ./%{php_pear_dir}/%{_class}/scripts docs/%{_pearname}
mv ./%{_bindir}/scripts/* docs/%{_pearname}/scripts

%install
rm -rf $RPM_BUILD_ROOT

install -d $RPM_BUILD_ROOT{%{_bindir},%{php_pear_dir},%{_smartyplugindir}}
%pear_package_install
cp -a ./%{_bindir}/phpdoc $RPM_BUILD_ROOT%{_bindir}
cp -a plugins/* $RPM_BUILD_ROOT%{_smartyplugindir}

%clean
rm -rf $RPM_BUILD_ROOT

%post
if [ -f %{_docdir}/%{name}-%{version}/optional-packages.txt ]; then
	cat %{_docdir}/%{name}-%{version}/optional-packages.txt
fi

%files
%defattr(644,root,root,755)
%doc install.log optional-packages.txt
%doc docs/%{_pearname}/*
%{php_pear_dir}/.registry/*.reg
%attr(755,root,root) %{_bindir}/phpdoc

%{php_pear_dir}/%{_class}
%{php_pear_dir}/data/%{_class}

# extra Smarty plugins
%{_smartyplugindir}/*

%files tests
%defattr(644,root,root,755)
%{php_pear_dir}/tests/*

%define	date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: php-pear-PhpDocumentor.spec,v $
Revision 1.28  2006/11/21 19:56:48  glen
- rel 2: use php(extension) virtuals

Revision 1.27  2006/10/25 14:57:09  glen
- 1.3.1

Revision 1.26  2006/09/04 20:57:35  glen
- 1.3.0 stable

Revision 1.25  2006/05/23 20:18:14  glen
- BR rpm-build macros >= 1.300 for %pear_ macros

Revision 1.24  2006/05/19 19:59:14  glen
- Smarty is now required
- use tokenizer for optimal results

Revision 1.23  2006/05/19 19:40:13  glen
- update to 1.3.0RC6

Revision 1.22  2006/04/02 13:48:06  glen
- AutoProv: no for -tests

Revision 1.21  2006/03/07 10:20:48  glen
- BR php-pear-PEAR

Revision 1.20  2006/02/20 21:48:14  glen
- group Development/Languages/PHP for -tests

Revision 1.19  2006/01/15 11:05:04  glen
- up to RC5

Revision 1.18  2005/10/27 19:07:14  qboosh
- define Epoch to 0 explicitly when using it

Revision 1.17  2005/10/26 14:55:31  glen
- smarty wasn't required before, don't add it now either

Revision 1.16  2005/10/26 14:51:52  glen
- use updated Smarty plugins dir
- fixed includes_fix patch
- rel .23

Revision 1.15  2005/10/06 19:34:29  glen
- rel .22 ;)

Revision 1.14  2005/10/03 22:59:16  glen
- semi automatically added deps from pear

Revision 1.13  2005/09/29 22:30:30  glen
- created tests subpackage

Revision 1.12  2005/09/29 19:58:12  glen
- updated 1.3.0RC3 from DEVEL. this one at least works

Revision 1.11.2.15  2005/09/29 19:54:43  glen
- update TODO

Revision 1.11.2.14  2005/09/19 17:36:33  glen
- macros moved to rpm-build

Revision 1.11.2.13  2005/09/18 12:40:26  glen
- use optional-packages.txt; unify; registry file fixed

Revision 1.11.2.12  2005/09/18 11:00:35  glen
- use php-pear-build

Revision 1.11.2.11  2005/09/18 10:09:20  glen
- such package method requires php-zlib

Revision 1.11.2.10  2005/09/18 09:54:09  glen
- use system Smarty

Revision 1.11.2.9  2005/09/18 09:23:20  glen
- pear/XML_Beautifier is optional

Revision 1.11.2.8  2005/09/18 09:04:04  glen
- freshes pear package devs

Revision 1.11.2.7  2005/08/25 10:17:16  arekm
- fix br

Revision 1.11.2.6  2005/08/25 10:04:42  glen
- commit my last changes, dated 2005-06-19

Revision 1.11.2.5  2005/06/19 17:04:13  glen
- missing dir
- NOTE: it doesn't work non-root now

Revision 1.11.2.4  2005/06/19 16:40:02  glen
- updated to 1.3.0RC3

Revision 1.11.2.3  2005/06/19 16:22:32  glen
- runtime pear registry stuff gone
- doesn't work with php5

Revision 1.11.2.2  2005/06/19 14:30:27  glen
- memory problem resolved

Revision 1.11.2.1  2005/06/19 14:26:24  glen
- worked with packaging using pear

Revision 1.11  2005/05/07 15:36:26  glen
- simplified install (the filelist is same with previous version with minor fixes. so it should be ok)

Revision 1.10  2005/05/06 21:23:01  glen
- fix dos file mode and path to php
- fix @DATA-DIR@
- add missing files
- works with php4

Revision 1.9  2004/10/30 07:07:26  paladine
- unifications

Revision 1.8  2004/05/30 13:13:52  adamg
- fixed english information about status of the package

Revision 1.7  2004/03/15 17:44:31  ankry
- massive cosmetics

Revision 1.6  2003/10/07 20:56:16  adamg
- do not use macros in URL

Revision 1.5  2003/08/31 20:49:11  adamg
- more specific URL

Revision 1.4  2003/08/31 10:41:06  adamg
- updated to 1.2.2.1

Revision 1.3  2003/08/06 12:40:45  adamg
- added -html_treemenu_includes_fix.patch
- removed HTML_TreeMenu - we will require proper package instead

Revision 1.2  2003/07/14 19:01:25  qboosh
- spell checking and other pl fixes
- simplified dirs creation a little (I hope that without mistakes...)

Revision 1.1  2003/07/11 19:50:23  adamg
- initial import into repository
- not finished yet - it still needs some work...
